<template>
  <main>
    <div class="width-ctrl welcome-ctr">
      <img
        src="../../public/icons/Artboard 2 copy 2.svg"
        class="icon-256 welcome-icon"
      />
      <h1>Bonjour, WeatherCast vous souhaite une bonne journée</h1>
      <form>
        <div class="form-block-50">
          <label>Ville</label>
          <div class="btn-input-ctr">
            <input
              type="text"
              v-model="ville"
              @blur="ChangeDisplayVille()"
              @focusin="displayVille = true"
              autocomplete="off"
              placeholder="Entrer la ville que vous voulez"
              @input="autoCompleteVille()"
            />
            <button
              @click="getTheLocalisationFromIpAddress()"
              type="button"
              class="input-button icon-button-primary-32"
            >
              <img
                class="icon-24"
                src="../../public/icons/Artboard 2 copy 6.svg"
              />
            </button>
            <SuggestedCities
              v-if="filterdVilles && displayVille && ville"
              :filteredVilles="filterdVilles"
              :setVille="setVille"
            />
          </div>
          <p class="error-message">{{ villeEmpty }}</p>
        </div>

        <div class="form-block-25">
          <label>Date</label>
          <div class="btn-input-ctr">
            <input v-model="dateSelected" type="date" />
          </div>
          <!-- display error message for heure -->
          <p class="error-message">{{ dateEmpty }}</p>
        </div>

        <div class="form-block-25">
          <label>Heure</label>
          <div class="btn-input-ctr">
            <input v-model="time" type="time" />
          </div>
          <!-- display error message for heure -->
          <p class="error-message">{{ heureEmpty }}</p>
        </div>

        <div class="form-block-50 radio-ctr">
          <label>Modèle Meteo</label>
          <button
            @click="modeleMeteo = 'GFS'"
            type="button"
            class="form-btn btn-secondary btn-active"
          >
            GFS
          </button>
          <button
            @click="modeleMeteo = 'GFES'"
            type="button"
            class="form-btn btn-secondary"
          >
            GFES
          </button>
        </div>

        <div class="form-block-50 check-ctr">
          <label>Informations</label>
          <button
            type="button"
            @click="information = 'temperature'"
            class="form-btn btn-secondary btn-active"
          >
            Température
          </button>
          <button
            type="button"
            @click="information = 'precipitation'"
            class="form-btn btn-secondary btn-active"
          >
            Précipitation
          </button>
          <button
            type="button"
            @click="information = 'vent'"
            class="form-btn btn-secondary"
          >
            Vitesse de vent
          </button>
        </div>

        <div class="buttons-ctr">
          <button
            type="button"
            @click="getWeatherByCityName()"
            class="form-btn btn-primary"
          >
            Valider
          </button>
        </div>
      </form>
    </div>

    <div class="width-ctrl cast-cards-ctr">
      <h1 style="max-width: 100000px; margin-bottom: 12px">
        Estimation Du Jour
      </h1>
      <h3 style="max-width: 100000px; margin-top: 0">
        {{ meteoActuelle.city || "" }} {{ date }}
      </h3>
      <br />
      <div
        style="
          width: 100%;
          display: flex;
          justify-content: center;
          align-items: center;
        "
      >
        <DayCard
          :meteoActuelle="meteoActuelle"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
      </div>
      <div v-for="categorie in categories" v-bind:key="categorie">
        <DayCard
          :meteoActuelle="meteoActuelle"
          :categorie="categorie"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
      </div>
    </div>
    <!-- Estimation par semaine -->
    <div class="width-ctrl scrolling-row">
      <h1
        style="
          max-width: 100000px;
          position: absolute;
          top: 10px;
          z-index: 5;
          color: white;
        "
      >
        Estimation Des 15 prochains jours
      </h1>
      <div class="cast-cards-ctr week-forecast">
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
        <ForecastCard
          date="2020-05-01"
          day="Lundi"
          windSpeed="28"
          temperature="12"
          precipitation="100"
        />
      </div>
    </div>
  </main>
</template>

<script>
import DayCard from "./DayCard.vue";
import ForecastCard from "./ForecastCard.vue";
import SuggestedCities from "./SuggestedCities";

export default {
  name: "Main",
  components: {
    DayCard,
    ForecastCard,
    SuggestedCities,
  },
  data() {
    return {
      villeEmpty: null,
      upHere: false,
      categories: ["Matin", "Apres-midi", "Soir", "Nuit"],
      dateEmpty: null,
      heureEmpty: null,
      gettingLocation: false,
      displayVille: false,
      meteoActuelle: null,
      filterdVilles: [],
      ville: "",
      villeLongitude: "",
      villeLatitude: "",
      dateSelected: "",
      date: "",
      errorStr: null,
      time: "",
      modeleMeteo: "",
      location: "",
      information: "",
    };
  },
  methods: {
    //auto complete méthode pour la ville
    autoCompleteVille() {
      this.filterdVilles = [];
      if (this.ville) {
        window.axios
          .get(this.environement + "/api/v1/cities", {
            params: {
              q: this.ville,
            },
          })
          .then((response) => {
            response.data.forEach((ville) => {
              this.filterdVilles.push([
                ville.name,
                ville.country.name,
                ville.longitude,
                ville.latitude,
              ]);
            });
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
    setVille(filterdVille) {
      if (filterdVille) {
        this.ville = filterdVille[0];
        this.villeLongitude = filterdVille[2];
        this.villeLatitude = filterdVille[3];
        this.displayVille = false;
        this.filterdVilles = [];
      } else {
        this.displayVille = false;
      }
    },
    //get city name with latitude and longitude
    getTheLocalisationFromIpAddress() {
      window.axios.get("https://ipinfo.io/?token=29ef7cace71e3c").then((response) => {
        this.ville = response.data.city ;
        var localisation= response.data.loc.split(',');
        this.villeLongitude = localisation[0];
        this.villeLatitude =  localisation[1];
      });
    },
    ChangeDisplayVille() {
      setTimeout(() => {
        this.displayVille = false;
      }, 200);
    },

    //get the date of the day with year and month and day
    getDate() {
      const mois = [
        "Janvier",
        "Février",
        "Mars",
        "Avril",
        "Mai",
        "June",
        "Juillet",
        "Aôut",
        "Septembre",
        "Octobre",
        "Novembre",
        "Décembre",
      ];
      const jours = [
        "Dimanche",
        "Lundi",
        "Mardi",
        "Mercredi",
        "Jeudi",
        "Vendredi",
        "Samedi",
      ];

      let date = new Date();
      let month = mois[date.getMonth()];
      let day = jours[date.getDay()];
      let year = date.getFullYear();
      this.date = day + " " + date.getDate() + " " + month + " " + year;
    },
    // Get the current location
    async geoLocation() {
      if (!("geolocation" in navigator)) {
        this.errorStr = "Geolocation is not available.";
        return;
      }
      this.gettingLocation = true;
      await navigator.geolocation.getCurrentPosition(
        (position) => {
          this.gettingLocation = false;
          this.location = position;
          this.getWeatherByLongitudeAndLatitude(position);
        },
        (err) => {
          this.gettingLocation = false;
          this.errorStr = err.message;
        }
      );
    },
    // Get the weather in the current location
    getWeatherByLongitudeAndLatitude(postion) {
      if (!postion) {
        this.errorStr = "No location found.";
        return;
      }
      this.gettingLocation = true;
      var formData = new FormData();
      formData.append("lat", postion.coords.latitude);
      formData.append("lon", postion.coords.longitude);
      window.axios
        .get(this.environement + "/api/v1/current_weather", {
          params: {
            lat: postion.coords.latitude,
            lon: postion.coords.longitude,
          },
        })
        .then((response) => {
          this.meteoActuelle = response.data;
        });
    },
    // Get the weather by city name and date and heure
    getWeatherByCityName() {
      this.villeEmpty = null;
      this.dateEmpty = null;
      this.heureEmpty = null;
      this.errorStr = false;
      if (!this.ville) {
        this.villeEmpty = "Veuillez saisir une ville";
        this.errorStr = true;
      }
      if (!this.dateSelected) {
        this.dateEmpty = "Veuillez saisir une date";
        this.errorStr = true;
      }
      if (!this.time) {
        this.heureEmpty = "Veuillez saisir une heure";
        this.errorStr = true;
      }
      if (this.errorStr) {
        return;
      }
      this.gettingLocation = true;
      var formData = new FormData();
      formData.append("longitude", this.villeLongitude);
      formData.append("latitude", this.villeLatitude);
      formData.append("date", this.dateSelected);
      formData.append("heure", this.time);

      window.axios
        .post(this.environement + "/api/getWeatherByVille", formData, {
          headers: { "Content-Type": "multipart/form-data" },
        })
        .then((response) => {
          console.log(response.data);
        });
    },
  },
  async mounted() {
    await this.geoLocation();
    this.getDate();
  },
};
</script>

<style>
.error-message {
  color: var(--color-secondary-2-0);
  height: 16px;
  display: block;
  width: 100%;
  font-size: 16px;
  margin: 2px 0 0;
}

.week-forecast {
  padding-right: 48px;
}

@media screen and (max-width: 1000px) {
  .welcome-ctr h1 {
    font-size: 32px;
    max-width: 80%;
    margin-top: 0;
  }

  .week-forecast {
    margin-left: 4px;
  }

  .welcome-ctr .welcome-icon {
    height: 128px;
    width: 128px;
  }

  .scrolling-row h1 {
    font-size: 38px;
  }
}

@media screen and (max-width: 700px) {
  .scrolling-row h1 {
    font-size: 32px;
  }
}

@media screen and (max-width: 500px) {
  .welcome-ctr {
    padding: 16px;
  }

  .welcome-ctr h1 {
    font-size: 28px;
    max-width: 90%;
    margin-top: 0;
  }

  .welcome-ctr .welcome-icon {
    height: 86px;
    width: 86px;
  }
}
</style>
